<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (97)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="node-properties-type-tag-and-contents">
      Node properties: type, tag and contents
    </h1>
    <p>Let’s get a more in-depth look at DOM nodes.</p>
    <p>
      In this chapter we’ll see more into what they are and learn their most
      used properties.
    </p>
    <h2 id="dom-node-classes">DOM node classes</h2>
    <p>
      Different DOM nodes may have different properties. For instance, an
      element node corresponding to tag <code>&lt;a&gt;</code> has link-related
      properties, and the one corresponding to <code>&lt;input&gt;</code> has
      input-related properties and so on. Text nodes are not the same as element
      nodes. But there are also common properties and methods between all of
      them, because all classes of DOM nodes form a single hierarchy.
    </p>
    <p>Each DOM node belongs to the corresponding built-in class.</p>
    <p>
      The root of the hierarchy is
      <a href="https://dom.spec.whatwg.org/#eventtarget">EventTarget</a>, that
      is inherited by
      <a href="http://dom.spec.whatwg.org/#interface-node">Node</a>, and other
      DOM nodes inherit from it.
    </p>
    <p>Here’s the picture, explanations to follow:</p>
    <p><img src="dom-class-hierarchy.svg" /></p>
    <p>The classes are:</p>
    <ul>
      <li>
        <a href="https://dom.spec.whatwg.org/#eventtarget">EventTarget</a> – is
        the root “abstract” class. Objects of that class are never created. It
        serves as a base, so that all DOM nodes support so-called “events”,
        we’ll study them later.
      </li>
      <li>
        <a href="http://dom.spec.whatwg.org/#interface-node">Node</a> – is also
        an “abstract” class, serving as a base for DOM nodes. It provides the
        core tree functionality: <code>parentNode</code>,
        <code>nextSibling</code>, <code>childNodes</code> and so on (they are
        getters). Objects of <code>Node</code> class are never created. But
        there are concrete node classes that inherit from it, namely:
        <code>Text</code> for text nodes, <code>Element</code> for element nodes
        and more exotic ones like <code>Comment</code> for comment nodes.
      </li>
      <li>
        <a href="http://dom.spec.whatwg.org/#interface-element">Element</a> – is
        a base class for DOM elements. It provides element-level navigation like
        <code>nextElementSibling</code>, <code>children</code> and searching
        methods like <code>getElementsByTagName</code>,
        <code>querySelector</code>. A browser supports not only HTML, but also
        XML and SVG. The <code>Element</code> class serves as a base for more
        specific classes: <code>SVGElement</code>, <code>XMLElement</code> and
        <code>HTMLElement</code>.
      </li>
      <li>
        <a href="https://html.spec.whatwg.org/multipage/dom.html#htmlelement"
          >HTMLElement</a
        >
        – is finally the basic class for all HTML elements. It is inherited by
        concrete HTML elements:
        <ul>
          <li>
            <a
              href="https://html.spec.whatwg.org/multipage/forms.html#htmlinputelement"
              >HTMLInputElement</a
            >
            – the class for <code>&lt;input&gt;</code> elements,
          </li>
          <li>
            <a
              href="https://html.spec.whatwg.org/multipage/semantics.html#htmlbodyelement"
              >HTMLBodyElement</a
            >
            – the class for <code>&lt;body&gt;</code> elements,
          </li>
          <li>
            <a
              href="https://html.spec.whatwg.org/multipage/semantics.html#htmlanchorelement"
              >HTMLAnchorElement</a
            >
            – the class for <code>&lt;a&gt;</code> elements,
          </li>
          <li>
            …and so on, each tag has its own class that may provide specific
            properties and methods.
          </li>
        </ul>
      </li>
    </ul>
    <p>
      So, the full set of properties and methods of a given node comes as the
      result of the inheritance.
    </p>
    <p>
      For example, let’s consider the DOM object for an
      <code>&lt;input&gt;</code> element. It belongs to
      <a
        href="https://html.spec.whatwg.org/multipage/forms.html#htmlinputelement"
        >HTMLInputElement</a
      >
      class.
    </p>
    <p>
      It gets properties and methods as a superposition of (listed in
      inheritance order):
    </p>
    <ul>
      <li>
        <code>HTMLInputElement</code> – this class provides input-specific
        properties,
      </li>
      <li>
        <code>HTMLElement</code> – it provides common HTML element methods (and
        getters/setters),
      </li>
      <li><code>Element</code> – provides generic element methods,</li>
      <li><code>Node</code> – provides common DOM node properties,</li>
      <li>
        <code>EventTarget</code> – gives the support for events (to be covered),
      </li>
      <li>
        …and finally it inherits from <code>Object</code>, so “plain object”
        methods like <code>hasOwnProperty</code> are also available.
      </li>
    </ul>
    <p>
      To see the DOM node class name, we can recall that an object usually has
      the <code>constructor</code> property. It references the class
      constructor, and <code>constructor.name</code> is its name:
    </p>
    <p>
      <code
        >js run alert(document.body.constructor.name); // HTMLBodyElement</code
      >
    </p>
    <p>…Or we can just <code>toString</code> it:</p>
    <p><code>js run alert(document.body); // [object HTMLBodyElement]</code></p>
    <p>We also can use <code>instanceof</code> to check the inheritance:</p>
    <p>
      <code
        >js run alert(document.body instanceof HTMLBodyElement); // true
        alert(document.body instanceof HTMLElement); // true alert(document.body
        instanceof Element); // true alert(document.body instanceof Node); //
        true alert(document.body instanceof EventTarget); // true</code
      >
    </p>
    <p>
      As we can see, DOM nodes are regular JavaScript objects. They use
      prototype-based classes for inheritance.
    </p>
    <p>
      That’s also easy to see by outputting an element with
      <code>console.dir(elem)</code> in a browser. There in the console you can
      see <code>HTMLElement.prototype</code>, <code>Element.prototype</code> and
      so on.
    </p>
    <p>
      ``<code>smart header="</code
      >console.dir(elem)<code>versus</code>console.log(elem)<code
        >" Most browsers support two commands in their developer tools:</code
      >console.log<code>and</code>console.dir`. They output their arguments to
      the console. For JavaScript objects these commands usually do the same.
    </p>
    <p>But for DOM elements they are different:</p>
    <ul>
      <li><code>console.log(elem)</code> shows the element DOM tree.</li>
      <li>
        <code>console.dir(elem)</code> shows the element as a DOM object, good
        to explore its properties.
      </li>
    </ul>
    <p>Try it on <code>document.body</code>.</p>
    <pre><code>
````smart header=&quot;IDL in the spec&quot;
In the specification, DOM classes aren&#39;t described by using JavaScript, but a special [Interface description language](https://en.wikipedia.org/wiki/Interface_description_language) (IDL), that is usually easy to understand.

In IDL all properties are prepended with their types. For instance, `DOMString`, `boolean` and so on.

Here&#39;s an excerpt from it, with comments:

```js
// Define HTMLInputElement
*!*
// The colon &quot;:&quot; means that HTMLInputElement inherits from HTMLElement
*/!*
interface HTMLInputElement: HTMLElement {
  // here go properties and methods of &lt;input&gt; elements

*!*
  // &quot;DOMString&quot; means that the value of a property is a string
*/!*
  attribute DOMString accept;
  attribute DOMString alt;
  attribute DOMString autocomplete;
  attribute DOMString value;

*!*
  // boolean value property (true/false)
  attribute boolean autofocus;
*/!*
  ...
*!*
  // now the method: &quot;void&quot; means that the method returns no value
*/!*
  void select();
  ...
}</code></pre>
    <pre><code>
## The &quot;nodeType&quot; property

The `nodeType` property provides one more, &quot;old-fashioned&quot; way to get the &quot;type&quot; of a DOM node.

It has a numeric value:
- `elem.nodeType == 1` for element nodes,
- `elem.nodeType == 3` for text nodes,
- `elem.nodeType == 9` for the document object,
- there are few other values in [the specification](https://dom.spec.whatwg.org/#node).

For instance:

```html run
&lt;body&gt;
  &lt;script&gt;
  let elem = document.body;

  // let&#39;s examine what it is?
  alert(elem.nodeType); // 1 =&gt; element

  // and the first child is...
  alert(elem.firstChild.nodeType); // 3 =&gt; text

  // for the document object, the type is 9
  alert( document.nodeType ); // 9
  &lt;/script&gt;
&lt;/body&gt;
```

In modern scripts, we can use `instanceof` and other class-based tests to see the node type, but sometimes `nodeType` may be simpler. We can only read `nodeType`, not change it.

## Tag: nodeName and tagName

Given a DOM node, we can read its tag name from `nodeName` or `tagName` properties:

For instance:

```js run
alert( document.body.nodeName ); // BODY
alert( document.body.tagName ); // BODY
```

Is there any difference between `tagName` and `nodeName`?

Sure, the difference is reflected in their names, but is indeed a bit subtle.

- The `tagName` property exists only for `Element` nodes.
- The `nodeName` is defined for any `Node`:
    - for elements it means the same as `tagName`.
    - for other node types (text, comment, etc.) it has a string with the node type.

In other words, `tagName` is only supported by element nodes (as it originates from `Element` class), while `nodeName` can say something about other node types.

For instance, let&#39;s compare `tagName` and `nodeName` for the `document` and a comment node:


```html run
&lt;body&gt;&lt;!-- comment --&gt;

  &lt;script&gt;
    // for comment
    alert( document.body.firstChild.tagName ); // undefined (not an element)
    alert( document.body.firstChild.nodeName ); // #comment

    // for document
    alert( document.tagName ); // undefined (not an element)
    alert( document.nodeName ); // #document
  &lt;/script&gt;
&lt;/body&gt;
```

If we only deal with elements, then we can use both `tagName` and `nodeName` - there&#39;s no difference.

```smart header=&quot;The tag name is always uppercase except in XML mode&quot;
The browser has two modes of processing documents: HTML and XML. Usually the HTML-mode is used for webpages. XML-mode is enabled when the browser receives an XML-document with the header: `Content-Type: application/xml+xhtml`.

In HTML mode `tagName/nodeName` is always uppercased: it&#39;s `BODY` either for `&lt;body&gt;` or `&lt;BoDy&gt;`.

In XML mode the case is kept &quot;as is&quot;. Nowadays XML mode is rarely used.
```


## innerHTML: the contents

The [innerHTML](https://w3c.github.io/DOM-Parsing/#the-innerhtml-mixin) property allows to get the HTML inside the element as a string.

We can also modify it. So it&#39;s one of the most powerful ways to change the page.

The example shows the contents of `document.body` and then replaces it completely:

```html run
&lt;body&gt;
  &lt;p&gt;A paragraph&lt;/p&gt;
  &lt;div&gt;A div&lt;/div&gt;

  &lt;script&gt;
    alert( document.body.innerHTML ); // read the current contents
    document.body.innerHTML = &#39;The new BODY!&#39;; // replace it
  &lt;/script&gt;

&lt;/body&gt;
```

We can try to insert invalid HTML, the browser will fix our errors:

```html run
&lt;body&gt;

  &lt;script&gt;
    document.body.innerHTML = &#39;&lt;b&gt;test&#39;; // forgot to close the tag
    alert( document.body.innerHTML ); // &lt;b&gt;test&lt;/b&gt; (fixed)
  &lt;/script&gt;

&lt;/body&gt;
```

```smart header=&quot;Scripts don&#39;t execute&quot;
If `innerHTML` inserts a `&lt;script&gt;` tag into the document -- it becomes a part of HTML, but doesn&#39;t execute.
```

### Beware: &quot;innerHTML+=&quot; does a full overwrite

We can append HTML to an element by using `elem.innerHTML+=&quot;more html&quot;`.

Like this:

```js
chatDiv.innerHTML += &quot;&lt;div&gt;Hello&lt;img src=&#39;smile.gif&#39;/&gt; !&lt;/div&gt;&quot;;
chatDiv.innerHTML += &quot;How goes?&quot;;
```

But we should be very careful about doing it, because what&#39;s going on is *not* an addition, but a full overwrite.

Technically, these two lines do the same:

```js
elem.innerHTML += &quot;...&quot;;
// is a shorter way to write:
*!*
elem.innerHTML = elem.innerHTML + &quot;...&quot;
*/!*
```

In other words, `innerHTML+=` does this:

1. The old contents is removed.
2. The new `innerHTML` is written instead (a concatenation of the old and the new one).

**As the content is &quot;zeroed-out&quot; and rewritten from the scratch, all images and other resources will be reloaded**.

In the `chatDiv` example above the line `chatDiv.innerHTML+=&quot;How goes?&quot;` re-creates the HTML content and reloads `smile.gif` (hope it&#39;s cached). If `chatDiv` has a lot of other text and images, then the reload becomes clearly visible.

There are other side-effects as well. For instance, if the existing text was selected with the mouse, then most browsers will remove the selection upon rewriting `innerHTML`. And if there was an `&lt;input&gt;` with a text entered by the visitor, then the text will be removed. And so on.

Luckily, there are other ways to add HTML besides `innerHTML`, and we&#39;ll study them soon.

## outerHTML: full HTML of the element

The `outerHTML` property contains the full HTML of the element. That&#39;s like `innerHTML` plus the element itself.

Here&#39;s an example:

```html run
&lt;div id=&quot;elem&quot;&gt;Hello &lt;b&gt;World&lt;/b&gt;&lt;/div&gt;

&lt;script&gt;
  alert(elem.outerHTML); // &lt;div id=&quot;elem&quot;&gt;Hello &lt;b&gt;World&lt;/b&gt;&lt;/div&gt;
&lt;/script&gt;
```

**Beware: unlike `innerHTML`, writing to `outerHTML` does not change the element. Instead, it replaces it in the DOM.**

Yeah, sounds strange, and strange it is, that&#39;s why we make a separate note about it here. Take a look.

Consider the example:

```html run
&lt;div&gt;Hello, world!&lt;/div&gt;

&lt;script&gt;
  let div = document.querySelector(&#39;div&#39;);

*!*
  // replace div.outerHTML with &lt;p&gt;...&lt;/p&gt;
*/!*
  div.outerHTML = &#39;&lt;p&gt;A new element&lt;/p&gt;&#39;; // (*)

*!*
  // Wow! &#39;div&#39; is still the same!
*/!*
  alert(div.outerHTML); // &lt;div&gt;Hello, world!&lt;/div&gt; (**)
&lt;/script&gt;
```

Looks really odd, right?

In the line `(*)` we replaced `div` with `&lt;p&gt;A new element&lt;/p&gt;`. In the outer document (the DOM) we can see the new content instead of the `&lt;div&gt;`. But, as we can see in line `(**)`, the value of the old `div` variable hasn&#39;t changed!

The `outerHTML` assignment does not modify the DOM element (the object referenced by, in this case, the variable &#39;div&#39;), but removes it from the DOM and inserts the new HTML in its place.

So what happened in `div.outerHTML=...` is:
- `div` was removed from the document.
- Another piece of HTML `&lt;p&gt;A new element&lt;/p&gt;` was inserted in its place.
- `div` still has its old value. The new HTML wasn&#39;t saved to any variable.

It&#39;s so easy to make an error here: modify `div.outerHTML` and then continue to work with `div` as if it had the new content in it. But it doesn&#39;t. Such thing is correct for `innerHTML`, but not for `outerHTML`.

We can write to `elem.outerHTML`, but should keep in mind that it doesn&#39;t change the element we&#39;re writing to (&#39;elem&#39;). It puts the new HTML in its place instead. We can get references to the new elements by querying the DOM.

## nodeValue/data: text node content

The `innerHTML` property is only valid for element nodes.

Other node types, such as text nodes, have their counterpart: `nodeValue` and `data` properties. These two are almost the same for practical use, there are only minor specification differences. So we&#39;ll use `data`, because it&#39;s shorter.

An example of reading the content of a text node and a comment:

```html run height=&quot;50&quot;
&lt;body&gt;
  Hello
  &lt;!-- Comment --&gt;
  &lt;script&gt;
    let text = document.body.firstChild;
*!*
    alert(text.data); // Hello
*/!*

    let comment = text.nextSibling;
*!*
    alert(comment.data); // Comment
*/!*
  &lt;/script&gt;
&lt;/body&gt;
```

For text nodes we can imagine a reason to read or modify them, but why comments?

Sometimes developers embed information or template instructions into HTML in them, like this:

```html
&lt;!-- if isAdmin --&gt;
  &lt;div&gt;Welcome, Admin!&lt;/div&gt;
&lt;!-- /if --&gt;
```

...Then JavaScript can read it from `data` property and process embedded instructions.

## textContent: pure text

The `textContent` provides access to the *text* inside the element: only text, minus all `&lt;tags&gt;`.

For instance:

```html run
&lt;div id=&quot;news&quot;&gt;
  &lt;h1&gt;Headline!&lt;/h1&gt;
  &lt;p&gt;Martians attack people!&lt;/p&gt;
&lt;/div&gt;

&lt;script&gt;
  // Headline! Martians attack people!
  alert(news.textContent);
&lt;/script&gt;
```

As we can see, only text is returned, as if all `&lt;tags&gt;` were cut out, but the text in them remained.

In practice, reading such text is rarely needed.

**Writing to `textContent` is much more useful, because it allows to write text the &quot;safe way&quot;.**

Let&#39;s say we have an arbitrary string, for instance entered by a user, and want to show it.

- With `innerHTML` we&#39;ll have it inserted &quot;as HTML&quot;, with all HTML tags.
- With `textContent` we&#39;ll have it inserted &quot;as text&quot;, all symbols are treated literally.

Compare the two:

```html run
&lt;div id=&quot;elem1&quot;&gt;&lt;/div&gt;
&lt;div id=&quot;elem2&quot;&gt;&lt;/div&gt;

&lt;script&gt;
  let name = prompt(&quot;What&#39;s your name?&quot;, &quot;&lt;b&gt;Winnie-the-Pooh!&lt;/b&gt;&quot;);

  elem1.innerHTML = name;
  elem2.textContent = name;
&lt;/script&gt;
```

1. The first `&lt;div&gt;` gets the name &quot;as HTML&quot;: all tags become tags, so we see the bold name.
2. The second `&lt;div&gt;` gets the name &quot;as text&quot;, so we literally see `&lt;b&gt;Winnie-the-Pooh!&lt;/b&gt;`.

In most cases, we expect the text from a user, and want to treat it as text. We don&#39;t want unexpected HTML in our site. An assignment to `textContent` does exactly that.

## The &quot;hidden&quot; property

The &quot;hidden&quot; attribute and the DOM property specifies whether the element is visible or not.

We can use it in HTML or assign it using JavaScript, like this:

```html run height=&quot;80&quot;
&lt;div&gt;Both divs below are hidden&lt;/div&gt;

&lt;div hidden&gt;With the attribute &quot;hidden&quot;&lt;/div&gt;

&lt;div id=&quot;elem&quot;&gt;JavaScript assigned the property &quot;hidden&quot;&lt;/div&gt;

&lt;script&gt;
  elem.hidden = true;
&lt;/script&gt;
```

Technically, `hidden` works the same as `style=&quot;display:none&quot;`. But it&#39;s shorter to write.

Here&#39;s a blinking element:


```html run height=50
&lt;div id=&quot;elem&quot;&gt;A blinking element&lt;/div&gt;

&lt;script&gt;
  setInterval(() =&gt; elem.hidden = !elem.hidden, 1000);
&lt;/script&gt;
```

## More properties

DOM elements also have additional properties, in particular those that depend on the class:

- `value` -- the value for `&lt;input&gt;`, `&lt;select&gt;` and `&lt;textarea&gt;` (`HTMLInputElement`, `HTMLSelectElement`...).
- `href` -- the &quot;href&quot; for `&lt;a href=&quot;...&quot;&gt;` (`HTMLAnchorElement`).
- `id` -- the value of &quot;id&quot; attribute, for all elements (`HTMLElement`).
- ...and much more...

For instance:

```html run height=&quot;80&quot;
&lt;input type=&quot;text&quot; id=&quot;elem&quot; value=&quot;value&quot;&gt;

&lt;script&gt;
  alert(elem.type); // &quot;text&quot;
  alert(elem.id); // &quot;elem&quot;
  alert(elem.value); // value
&lt;/script&gt;
```

Most standard HTML attributes have the corresponding DOM property, and we can access it like that.

If we want to know the full list of supported properties for a given class, we can find them in the specification. For instance, `HTMLInputElement` is documented at &lt;https://html.spec.whatwg.org/#htmlinputelement&gt;.

Or if we&#39;d like to get them fast or are interested in a concrete browser specification -- we can always output the element using `console.dir(elem)` and read the properties. Or explore &quot;DOM properties&quot; in the Elements tab of the browser developer tools.

## Summary

Each DOM node belongs to a certain class. The classes form a hierarchy. The full set of properties and methods come as the result of inheritance.

Main DOM node properties are:

`nodeType`
: We can use it to see if a node is a text or an element node. It has a numeric value: `1` for elements,`3` for text nodes, and a few others for other node types. Read-only.

`nodeName/tagName`
: For elements, tag name (uppercased unless XML-mode). For non-element nodes `nodeName` describes what it is. Read-only.

`innerHTML`
: The HTML content of the element. Can be modified.

`outerHTML`
: The full HTML of the element. A write operation into `elem.outerHTML` does not touch `elem` itself. Instead it gets replaced with the new HTML in the outer context.

`nodeValue/data`
: The content of a non-element node (text, comment). These two are almost the same, usually we use `data`. Can be modified.

`textContent`
: The text inside the element: HTML minus all `&lt;tags&gt;`. Writing into it puts the text inside the element, with all special characters and tags treated exactly as text. Can safely insert user-generated text and protect from unwanted HTML insertions.

`hidden`
: When set to `true`, does the same as CSS `display:none`.

DOM nodes also have other properties depending on their class. For instance, `&lt;input&gt;` elements (`HTMLInputElement`) support `value`, `type`, while `&lt;a&gt;` elements (`HTMLAnchorElement`) support `href` etc. Most standard HTML attributes have a corresponding DOM property.

However, HTML attributes and DOM properties are not always the same, as we&#39;ll see in the next chapter.</code></pre>
  </body>
</html>
